(LeetCode) Best Time to Buy and Sell Stock - LeetCode

Description: 

Say you have an array for which the ith element is the price of a given stock on day i.

 

If you were only permitted to complete at most one transaction (i.e., buy one and sell one share of the stock), design an algorithm to find the maximum profit.

 

Note that you cannot sell a stock before you buy one.

 

Example 1:

 

Input: [7,1,5,3,6,4]
Output: 5
Explanation: Buy on day 2 (price = 1) and sell on day 5 (price = 6), profit = 6-1 = 5.
             Not 7-1 = 6, as selling price needs to be larger than buying price.

 

Example 2:

 

Input: [7,6,4,3,1]
Output: 0
Explanation: In this case, no transaction is done, i.e. max profit = 0.

 

Solution:

class Solution {
    public int maxProfit(int[] prices) {
        
        if(prices==null||prices.length==0){
            return 0;
        }
        
        int max_profit =0;
        for(int i = 0; i< prices.length; i++){
            
            int buy = prices[i];
            
            int sell = getMax(prices, i);
            
            if((sell-buy)>max_profit){
                max_profit = sell-buy;
            }
        }
        
        return max_profit;
    }
    
    public int getMax(int [] arr, int pos){
        int max= 0;
        for(int i = pos+1; i<arr.length; i++){
            
            if(arr[i]>max){
                max = arr[i];
            }
        }
        
        return max;
    }
     /*   Second solution:
        //Category Analysis dynamic Programming. 
        
        //Special cases
        if(prices ==null || prices.length==0){
            return 0;
        }
        
        int [] dp = new int[prices.length];
        
       //dp[i] denotes that the max profit you can get on day i;
         dp[0] = 0;
       
        for(int i = 1; i<prices.length; i++){
            
          //dp[i]  
            int min = getMin(prices, i);
            
            dp[i] = getMax(dp[i-1], prices[i]-min);
           
         }
        
        
         Arrays.sort(dp);
        
        return dp[dp.length-1];
    }
    
    static int getMax(int a,   int b){
        int tmp =0; 
        if(a<b){
            tmp = b; 
        }else{
            tmp =a;
        }
        
         return tmp;
    }
    
    static int getMin(int[] arr, int k){
        int min = Integer.MAX_VALUE;
        for(int i = 0; i<k;i++){
            if(arr[i]<min){
                min = arr[i];
            }
        }
        return min;
    }
    */
}

 

 

Say you have an array for which the ith element is the price of a given stock on day i.

If you were only permitted to complete at most one transaction (i.e., buy one and sell one share of the stock), design an algorithm to find the maximum profit.

Note that you cannot sell a stock before you buy one.

Example 1:

Input: [7,1,5,3,6,4]
Output: 5
Explanation: Buy on day 2 (price = 1) and sell on day 5 (price = 6), profit = 6-1 = 5.
             Not 7-1 = 6, as selling price needs to be larger than buying price.

Example 2:

Input: [7,6,4,3,1]
Output: 0
Explanation: In this case, no transaction is done, i.e. max profit = 0.
posted @ 2019-09-03 16:52  CodingYM  阅读(96)  评论(0编辑  收藏  举报